using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {        
        private bool isMouseDown = false;
        private int oldX;
        private int oldY;

        public Form1()
        {
            InitializeComponent();
            this.SuspendLayout();
            this.Size = new Size(35, 35);
            this.ResumeLayout();
        }

        private void FmDragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop) || e.Data.GetDataPresent(DataFormats.StringFormat))
            {
                if ((e.AllowedEffect & DragDropEffects.Move) != 0)
                    e.Effect = DragDropEffects.Move;
                if (((e.AllowedEffect & DragDropEffects.Copy) != 0) && ((e.KeyState & 0x08) != 0))
                    e.Effect = DragDropEffects.Copy;
            }
        }

        private void FmDragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                string[] astr = (string[])e.Data.GetData(DataFormats.FileDrop);
                Clipboard.SetText(astr[0]);
            }
        }

        private void mouseDown(object sender, MouseEventArgs e)
        {
            oldX = e.X;
            oldY = e.Y;
            isMouseDown = true;            
        }

        private void mouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                this.Location = new Point(e.X+this.Location.X-oldX, e.Y+this.Location.Y-oldY);                
            }
        }

        private void mouseUp(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                isMouseDown = false;
            }
        }        

        private void Keypressed(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 'q')
                this.Close();
        }
    }
}